// written 2004 Mirko Roller   mirko@mirkoroller.de
// Example shows you how to use the Chatboard
//
// You must press the "SMS" key, before "normal" keys are working.
// This is a Hardware thing, so dont flame me...
// Also if you pressed the "YES,NO,Phonebook" key, to get back to "normal" state
// press the "SMS" key.


#include "gp32.h"

unsigned short *framebuffer;


int main() {
  int x,y,init;
  char get;
  char buffer[1024];
  framebuffer = (u16*) FRAMEBUFFER;
  gp_setCpuspeed(33);  
  gp_initFramebuffer(framebuffer,16,85);
  gp_clearFramebuffer16(framebuffer,0xFFFF); // Clear Screen

  //   gp_ChatBoardInit  returns "1" on Chatboard found
  //                     returns "0" on NO Chatboard found
  //   If no chatboard is connected, the "detecting" could take up to 5 seconds,
  //   depending on Cpuclock  
  init = gp_initChatboard();
  
  if (init) {

   gp_drawString(30,2,14,"Press SMS Key   ",0xF800,framebuffer);
   y=0;
   while (1) {
     for (x=0;x<1000000;x++) x=x;   // Some waiting

     //  ChatBoardGetLastKey  returns "0" on no key pressed
     //                       returns ascii code on key pressed
     get=gp_getChatboard();
     
     if (get >0) {
       if (y == 20 ) {y=0;gp_clearFramebuffer16(framebuffer,0xFFFF);}
       sprintf (buffer,"-%d %c-     ",get,get);
       gp_drawString(30,20+(y++*8),10,buffer,0xF800,framebuffer);
     }
   }

  }
  else  gp_drawString(30,50,23,"NO Chatboard Found :(   ",0xF800,framebuffer);



  while (1) { } 
}
