// written 2004 Mirko Roller   mirko@mirkoroller.de
// Example shows you how to use the RTC timer

#include "gp32.h"

unsigned short *framebuffer;

int main() {

  long rtctimer;
  int x;
  framebuffer = (u16*) FRAMEBUFFER;
  gp_setCpuspeed(33);
  gp_initFramebuffer(framebuffer,16,85);

  // Start 1/63 Timer
  // ~3800 ticks / per minute
  gp_initRTC();
  
 while (1) {
  for (x=0;x<320*240;x++) framebuffer[x]=0xFFFF; // Clear Screen

  { char text[80];
    // Get the actual TickCounter
    rtctimer = gp_getRTC();
    sprintf (text,"1/128 TIMER: %d             ",rtctimer);
    gp_drawString(30,100,25,text,0xF800,framebuffer);
  }
  for (x=0;x<900000;x++) x=x;

 if ( gp_getButton()&BUTTON_A) gp_Reset();
 if ( gp_getButton()&BUTTON_B) gp_clearRTC(); // Set Tickcounter to 0, still running.
 }
  
}


