// written 2004 Mirko Roller   mirko@mirkoroller.de
// Example shows you how to use the select Box

#include "gp32.h"
//#include "sbox.h"

unsigned short *framebuffer;

int main() {

  int x;
  int select;
  SELECTBOX sbox;
  
  framebuffer = (u16*) FRAMEBUFFER;
  gp_setCpuspeed(33);
  gp_initFramebuffer(framebuffer,16,85);
    
  for (x=0;x<320*240;x++) framebuffer[x]=0xFFFF; // Clear Screen


  sbox.x = 50;
  sbox.y = 50;
  sbox.bannercolor = 0xF800;
  strcpy (sbox.banner,"Select your car Brand");
  sbox.textcolor = 0xF800>>5;   // Green
  sbox.boxcolor  = 0xF800>>10;  // Blue
  strcpy (sbox.text[0],"Audi");
  strcpy (sbox.text[1],"Fiat");
  strcpy (sbox.text[2],"Mercedes");
  sbox.entrys = 3;
  
  
  select=gp_drawSelectbox ( &sbox,framebuffer );

  { char buffer[30];
    sprintf (buffer,"You selected :%s",sbox.text[select]);
    gp_drawString(50,200,strlen(buffer),buffer,0xf800,framebuffer);
  }
  

  while (1) { if ( gp_getButton()&BUTTON_B) gp_Reset();  }
  
}

