// zdaread.c written 2004 Mr.Mirko

#include "gp32.h"
#include "zda.h"

int main() {

  //DIR dir_struct;
  //int dir_entrys;
  int x,err;
  
  unsigned short *framebuffer1;
  framebuffer1 = (u16*) FRAMEBUFFER1;
  gp_setCpuspeed(33);
  gp_initFramebuffer(framebuffer1,16,85);
  gp_clearFramebuffer16(framebuffer1,0xFFFF);


   // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   // USING NEW ZDA FORMAT WITH HEADER
   // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
   //
   // I compressed 3 files to the datah.zda file
   // Makefile, README.TXT, zda_compressor.c
   // You no longer need to know size or offset position

   { char header_12bytes[12];  // The ZDA header is always 12 Bytes big
     char *full_header;        // The full headersize depend on content
     char *compressed;
     char *uncompressed;
     int  real_headersize;
     int  usize,csize,offset,err;

     smc_read("dev0:\\GPMM\\datah.zda",header_12bytes,0,12); // read in the 12 bytes header.
     real_headersize=gp_zda_headersize(header_12bytes);      // calculate the real headersize

     full_header = (char*) malloc(real_headersize);          // malloc space for full header
     smc_read("dev0:\\GPMM\\datah.zda",full_header,0,real_headersize); // read in the full header

     csize  = gp_zda_csize (full_header, "README.TXT");     // get compressed   size of file README.TXT
     usize  = gp_zda_usize (full_header, "README.TXT");     // get uncompressed size of file README.TXT
     offset = gp_zda_offset(full_header, "README.TXT");     // get the offset for file README.TXT, counting from file beginning

     compressed   = (char*) malloc(csize);  // temp buffer for compressed file
     uncompressed = (char*) malloc(usize);  // buffer for uncompressed data
     err=smc_read("dev0:\\GPMM\\datah.zda",compressed,offset,csize);  // read in the compressed data

     gp_drawString(10,100,26,"Uncompressing file ...   ",0xF800,framebuffer1);
     err = gp_uncompressZDA( (u8*)uncompressed, &usize, (u8*)compressed, csize ); // uncompress
     if (err == 0) gp_drawString(10,110,20,uncompressed,0xF800,framebuffer1);
     if (err == 1) gp_drawString(10,110, 6,"ERROR ",0xF800,framebuffer1);

     // free all memory
     free (full_header);
     free (compressed);
     free (uncompressed);
   }



while (1) { if ( gp_getButton()&BUTTON_A) gp_Reset();  }
}

