; Startup code for ADS 1.2 by nanjungho
; User must set link option -first crt0.o(init)
;////////////////////////////////////////////////////////////////////////////@
;// crt0.S                                                                  /@
;////////////////////////////////////////////////////////////////////////////@
		AREA init, CODE, READONLY
		
   		EXPORT __user_initial_stackheap
   		IMPORT |Image$$RO$$Base| 	; Base of ROM code
		IMPORT |Image$$RO$$Limit| 	; End of ROM code (=start of ROM data)
		IMPORT |Image$$RW$$Base| 	; Base of RAM to initialize
		IMPORT |Image$$RW$$Limit| 	; End of ROM code (=start of ROM data)
		IMPORT |Image$$ZI$$Base| 	; Base and limit of area
		IMPORT |Image$$ZI$$Limit| 	; to zero initialize
		IMPORT __main
		; HEADER
		
		ENTRY
		B		_START	
		DCD		|Image$$RO$$Base|	; ?
		DCD		|Image$$RO$$Limit|	; End of ROM code (=start of ROM data)
		DCD		|Image$$RW$$Base|	; Base of RAM to initialize           
		DCD		|Image$$RW$$Limit|	; ?                                   
		DCD		|Image$$ZI$$Base|	; Base and limit of area              
_HEAPSTART		
		DCD		|Image$$ZI$$Limit|	;
_STACKSTART
		DCD		0x0C77FF00			 ; same as geepee32(emulator)

__user_initial_stackheap
		LDR   r0,_HEAPSTART
		LDR   r1,_STACKSTART
		; r2 not used (HL)                  ; The heap limit and stack limit are not used
		; r3 not used (SL)                  ; in a one-region model
		MOV   pc,lr

_START
        mrs             r0, CPSR
        orr             r0, r0, #0xC0
        msr             CPSR_c, r0

        mrs             r0, CPSR
        bic             r0, r0, #0xC0
        orr             r0, r0, #0x40
        msr             CPSR_c, r0

        B       __main   ; note use B not BL, because an application will never return this way

        END

		
