
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main(int argc,char *argv[])
{
    long pow2[]={1L,2L,4L,8L};
    char str[20];
    long mclk,clkXtal,tmpMclk,bMclk,fVco,max_fvco;
    long m,p,s,bm,bp;
    long temp;
    long tmp,freqDiff,freqDiffMin;
    float par1,par2,par3,par4;
    int pass;
	
    printf("     +---------------------------------------+\n");
    printf("     | PLL VALUE CALCULATER        Ver 1.22  |\n");
    printf("     | Fixed for S3C2400X/S3C2410X/S3CA400X  |\n");
    printf("     +---------------------------------------+\n");
    printf(" Updated by Mr.Mirko \n");

    //printf (" %2.2d\n",2);
    
    if (argc<2)
    {
	printf("Revision History:\n");
	printf("Usage:pllset <output freq>\n");
	//printf("dev_id:  1 :S3C44B0X,S3C44A0X\n");
	//printf("         2 :S3C2400X/S3C2410X/S3CA400X\n");
	exit(0);
    }
    //if(atoi(argv[1])==1)max_fvco=(long)(170000000*1.01); //S3C44B0X,S3C44A0X
    //else if(atoi(argv[1])==2)max_fvco=(long)(600000000*1.01); //S3C2400
    //else
    //{
	//printf("ERROR:unknown device ID.\n");
	//return;
    //}
    max_fvco = (long)(600000000*1.01);
    clkXtal= 12000000;	//atol(argv[1]);
    mclk=atol(argv[1]);

    printf("Input XTAL0 Freq:%ld\n",clkXtal);
    printf("Output MCLK Freq:%ld\n",mclk);
    printf("MPS   |MCLK     |fvco|fi/P+2|PAR1<PAR2<PAR3|P|PAR4|\n");    
	for(s=0L;s<4L;s++)
	{
	    for(p=0L;p<64L;p++)
	    {
		tmp=(p+2L)*pow2[s];
		freqDiffMin=500000L;
		bm=256L;
		for(m=0;m<256L;m++)
		{
		    tmpMclk=clkXtal*(m+8L)/tmp;
		    freqDiff=labs(mclk-tmpMclk);
		    if(freqDiff<freqDiffMin)
		    {
			fVco=tmpMclk*pow2[s];
			if(fVco<=max_fvco)
			{
			    freqDiffMin=freqDiff;
			    bm=m;
			    bMclk=tmpMclk;
			}
		    }
		}
		par1=clkXtal/(25*(p+2))/1000000.;
		par2=16700000./(bm+8)/1000000.;
		par3=clkXtal/(10*(p+2))/1000000.;
		par4=6.48/pow(bm+8,0.5); 
		pass=(par1<=par2)&&(par2<=par3)&&(bm>=4)&&(bm<=0x4e); 
		if((bm!=256L) && (par4>0.6) && (par4<1.9 ) && (pass>0) && (pass <4) &&((fVco/1000000L)<330)  )
		    printf("CLKDIV=0x%2.2lx%2.2lx%1.1lx; MCLK=%9ld; CLKMODE=%d;\n",bm,p,s,bMclk,pass);
	    }
	}
    
    printf("\n");


}

